unit LeDXF;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, OGLClass, OGLCam, OGLView, UDXF, UExibe, OpenGL, ExtCtrls,
  Menus, Buttons,UAux;

type
  TForm1 = class(TForm)
    View3D: TOGLView;
    Cam: TOGLCamera;
    AngVis: TScrollBar;
    Label1: TLabel;
    CamX: TScrollBar;
    CamY: TScrollBar;
    CamZ: TScrollBar;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Panel1: TPanel;
    BotAbrir: TSpeedButton;
    BotSair: TSpeedButton;
    MainMenu1: TMainMenu;
    Arquivo1: TMenuItem;
    Abrir1: TMenuItem;
    N1: TMenuItem;
    Sair1: TMenuItem;
    OpenDialog: TOpenDialog;
    RotX: TScrollBar;
    RotY: TScrollBar;
    RotZ: TScrollBar;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    procedure LeArquivo (nome:string);
    procedure View3DPaint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure AngVisChange(Sender: TObject);
    procedure CamXChange(Sender: TObject);
    procedure CamYChange(Sender: TObject);
    procedure CamZChange(Sender: TObject);
    procedure Abrir1Click(Sender: TObject);
    procedure Sair1Click(Sender: TObject);
    procedure BotAbrirClick(Sender: TObject);
    procedure BotSairClick(Sender: TObject);
    procedure RotYChange(Sender: TObject);
    procedure RotXChange(Sender: TObject);
    procedure RotZChange(Sender: TObject);
    procedure Selecao;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

Var
   PodeDesenhar: boolean;
   OBJSelecionado: integer;
   Versor, OBJPtInsOriginal: TPonto3D;

////////////////////////////////////////////////////////////////////////////////
procedure PosicionaLuz;
const
  ambientlight : array [0..2] of GLFloat = (0.25,0.25,0.25);
  diffuselight : array [0..2] of GLFloat = (0.9,0.9,0.9);
  specularlight: array [0..3] of GLFloat = (0.828,0.828,0.828,1.0);
  light1position: array [0..3] of GLFloat = (0,0,10,1);

begin
  glClearColor(0, 0, 0, 1.0);	// --- Preto como cor de fundo
  glShadeModel (GL_SMOOTH);		// --- Sombreado
  glEnable(GL_NORMALIZE);			// --- Diz pro opengl calcular os ...
  														// ... vetores unitrios (NORMAIS). Normalizar os vetores

  glEnable (GL_DEPTH_TEST);   // --- Z-BUFFER
  glEnable (GL_CULL_FACE);		// --- Remoao da face traseira
	glEnable (GL_LIGHTING);
 	glEnable (GL_COLOR_MATERIAL);
  glColorMaterial(GL_FRONT,GL_DIFFUSE);

	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);

	glLightModelfv(GL_LIGHT_MODEL_AMBIENT, @AmbientLight);
//	glLightModelI(GL_LIGHT_MODEL_TWO_SIDE, GL_TRUE);

	glLightfv (GL_LIGHT0, GL_AMBIENT, @AmbientLight);
	glLightfv (GL_LIGHT0, GL_DIFFUSE, @DiffuseLight);
//	glLightfv (GL_LIGHT0, GL_SPECULAR,@SpecularLight);

	glLightfv (GL_LIGHT1, GL_AMBIENT, @AmbientLight);
	glLightfv (GL_LIGHT1, GL_DIFFUSE, @DiffuseLight);
	glLightfv (GL_LIGHT1, GL_POSITION,@Light1Position);

	glMaterialfv (GL_FRONT_AND_BACK, GL_AMBIENT, @ambientlight);
	glMaterialfv (GL_FRONT_AND_BACK, GL_DIFFUSE, @diffuselight);
//	glMaterialfv (GL_FRONT_AND_BACK, GL_SPECULAR,@specularlight);
	glMateriali  (GL_FRONT_AND_BACK, GL_EMISSION, 80);
	glMaterialf  (GL_FRONT_AND_BACK, GL_SHININESS, 128);

  glEnable(GL_LIGHT0);	// --- Habilita a luz '0' (fixa)
  glEnable(GL_LIGHT1);  // --- Habilita a luz '1' (movel)
end;
////////////////////////////////////////////////////////////////////////////////
procedure TForm1.LeArquivo (nome:string);
Var
   MinX, MinY, MinZ, MaxX, MaxY, MaxZ, x, y, z:real;
begin
   InformaLimites(MinX, MinY, MinZ, MaxX, MaxY, MaxZ);
   DXFLeitor(nome);
   CamX.Position:=500;
   CamY.Position:=500;
   CamZ.Position:=500;
   RotX.Position:=0;
   RotY.Position:=0;
   RotZ.Position:=0;
   PodeDesenhar := true;
end;
////////////////////////////////////////////////////////////////////////////////
procedure TForm1.View3DPaint(Sender: TObject);
Var
   MinX, MinY, MinZ, MaxX, MaxY, MaxZ, x, y, z:real;
begin
   InformaLimites(MinX, MinY, MinZ, MaxX, MaxY, MaxZ);
//   PodeDesenhar:=false;
   if PodeDesenhar
   then
       begin
            PosicionaLuz;
            x:=1000/(MaxX-MinX);
            y:=1000/(MaxY-MinY);
            z:=1000/(MaxZ-MinZ);
            Cam.Position.X:=CamX.Position/x + MinX;
            Cam.Position.Y:=CamY.Position/y + MinY;
            Cam.Position.Z:=(CamZ.Position/z + MinZ)+MaxZ;
            glPushMatrix();
               glRotatef(RotX.Position,1,0,0);
               glRotatef(RotY.Position,0,1,0);
               glRotatef(RotZ.Position,0,0,1);
               ExibeFACE3D (LFace3D, true);
               ExibeLine(LLinha);
               ExibeArc(LArco);
               ExibePolyLine(LPolyLine);
               ExibeCircle(LCirculo);
               ExibeInsert(1);
               Selecao;
            glPopMatrix();
        end;
end;
////////////////////////////////////////////////////////////////////////////////
procedure TForm1.FormCreate(Sender: TObject);
begin
   PodeDesenhar := false;
end;
////////////////////////////////////////////////////////////////////////////////
procedure TForm1.AngVisChange(Sender: TObject);
begin
   Cam.ViewAngle := AngVis.Position;
end;
////////////////////////////////////////////////////////////////////////////////
procedure TForm1.CamXChange(Sender: TObject);
begin
     View3D.InvalidateGL;
end;
////////////////////////////////////////////////////////////////////////////////
procedure TForm1.CamYChange(Sender: TObject);
begin
     View3D.InvalidateGL;
end;
////////////////////////////////////////////////////////////////////////////////
procedure TForm1.CamZChange(Sender: TObject);
begin
     View3D.InvalidateGL;
end;
////////////////////////////////////////////////////////////////////////////////
procedure TForm1.Abrir1Click(Sender: TObject);
begin
 OpenDialog.FileName := '*.dxf';
  if OpenDialog.Execute
  then begin
           LeArquivo(OpenDialog.FileName);
           View3D.InvalidateGL;
       end;
end;
////////////////////////////////////////////////////////////////////////////////
procedure TForm1.Sair1Click(Sender: TObject);
begin
     Form1.Close;
end;
////////////////////////////////////////////////////////////////////////////////
procedure TForm1.BotAbrirClick(Sender: TObject);
begin
     Form1.Abrir1Click(Sender);
end;
////////////////////////////////////////////////////////////////////////////////
procedure TForm1.BotSairClick(Sender: TObject);
begin
     Form1.Sair1Click(Sender);
end;
                                    


procedure TForm1.RotYChange(Sender: TObject);
begin
     View3D.InvalidateGL;
end;

procedure TForm1.RotXChange(Sender: TObject);
begin
        View3D.InvalidateGL;
end;

procedure TForm1.RotZChange(Sender: TObject);
begin
        View3D.InvalidateGL;
end;

procedure TForm1.Selecao;
var
   P,R: TPonto3D;
begin
      P:=TPonto3D.Create;
      R:=TPonto3D.Create;
      AtribuiP3D1(4,3,-10,P);
      AtribuiP3D1(4,3,40,R);
      OBJSelecionado:=verifica_selecao(R,P);
      {GlBegin(GL_LINES);
        glcolor3f(1,1,1);
        glvertex3f(4,3,-10);
        glvertex3f(4,3,40);
      GlEnd;}
end;

end.
